<template>
  <div class="login-photo">
    <el-container>
      <div class="form-container">
        <el-aside>
            <div></div>
        </el-aside>
        <el-main>
          <h2 align="center"><strong>卡路里大作战</strong></h2>
            <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="100px" class="demo-ruleForm">
              <el-form-item label="用户账号" prop="username">
                  <el-input v-model="ruleForm.username" placeholder="请输入账号"></el-input>
              </el-form-item>
              <el-form-item label="用户密码" prop="password">
                  <el-input type="password" v-model="ruleForm.password" placeholder="请输入密码"></el-input>
              </el-form-item>
              <el-form-item label="记住密码" prop="remember">
                  <el-switch v-model="ruleForm.remember"></el-switch>
              </el-form-item>
              <el-row type="flex" class="row-bg" justify="space-around">
                  <el-col :span="6">
                    <el-popover placement="top" width="200" v-model="visible" title="登录失败！" trigger="manual">
                      <p>{{msg}}</p>
                      <div style="text-align: right; margin: 0">
                        <el-button slot = "reference" type="primary" size="mini" @click="visible = false">确定</el-button>
                      </div>
                      <el-button slot="reference" type="danger" @click="login()">立即登录</el-button>
                    </el-popover>
                  </el-col>
                  <el-col :span="6">
                      <el-button type="primary" plain @click="forgetPassword()">忘记密码</el-button>
                  </el-col>
              </el-row>
            </el-form>
            <div align="center"><el-link type="info" align="center" :underline="false" @click="toRegister">还没有账号?立即注册!</el-link></div>
        </el-main>
      </div>
    </el-container>
  </div>
</template>
<script>
import loginService from '@/services/loginService'

export default {
  name: 'Login',
  data () {
    return {
      visible: false,
      ruleForm: {
        // 测试用初始值
        username: '',
        password: '',
        remember: false
      },
      rules: {
        username: [
          { required: true, message: '请输入用户名', trigger: 'blur' },
          { min: 3, max: 15, message: '长度在 3 到 15 个字符', trigger: 'blur' }
        ],
        password: [
          { required: true, message: '请输入密码', trigger: 'change' }
        ]
      },
      msg: '用户账号或密码错误！'
    }
  },
  methods: {
    async login () {
      try {
        this.msg = '用户账号或密码错误！'
        const response = await loginService.login({
          userName: this.ruleForm.username,
          userPassword: this.ruleForm.password
        })
        if (response.data.code === 200) {
          this.$store.commit('SET_TOKEN', response.data.data.token)
          this.$store.commit('SET_USERINFO', response.data.data.user)
          this.$store.commit('SET_ROLES', response.data.data.roles)
          if (this.ruleForm.remember) {
            this.$store.commit('SET_USERINFO', response.data.data.user)
          }
          this.$alert('您已经成功登录！', '登录成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/')
            }
          })
        } else this.visible = true
      } catch (error) {
        this.visible = true
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.msg = 'Network Error'
        } else {
          this.msg = error.response.data.error
        }
      }
    },
    forgetPassword () {
      this.$router.push('/forgetpassword')
    },
    toRegister: function () {
      this.$router.push('/register')
    }
  }
}
</script>

<style scoped>
.el-header,
.el-footer {
  text-align: center;
}
.el-aside {
    display:table-cell;
    width:auto;
    background:url(../assets/Login.png) 0 0/cover
}
.el-main {
  display:table-cell;
  width:300px;
  background-color:#fff;
  padding:40px 60px;
  color:#505e6c
}
.mlogo {
  height: 100%;
}

.demo-ruleForm {
  max-width: 500px;
  margin: 0 auto;
}
.login-photo
{
    height: 100%;
    background:#f1f7fc;
    padding:80px 0
}
.login-photo
{
    background:#f1f7fc;
    padding:80px 0
}
.login-photo .form-container
{
    display:table;
    max-width:900px;
    width:90%;
    margin:0 auto;
    box-shadow:1px 1px 5px rgba(0,0,0,.1)
}
.row-bg {
    padding: 10px 0;
}
</style>
